/[gentoo-x86]/eclass/elisp-common.eclass
Gentoo

Diff of /eclass/elisp-common.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.11 Revision 1.24
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/elisp-common.eclass,v 1.11 2005/07/06 20:20:03 agriffis Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/elisp-common.eclass,v 1.24 2007/07/10 20:14:52 ulm Exp $
4# 4#
5# Copyright 2007 Christian Faulhammer <opfer@gentoo.org>
5# Copyright 2002-2003 Matthew Kennedy <mkennedy@gentoo.org> 6# Copyright 2002-2004 Matthew Kennedy <mkennedy@gentoo.org>
7# Copyright 2004-2005 Mamoru Komachi <usata@gentoo.org>
6# Copyright 2003 Jeremy Maitin-Shepard <jbms@attbi.com> 8# Copyright 2003 Jeremy Maitin-Shepard <jbms@attbi.com>
9# Copyright 2007 Ulrich Mueller <ulm@gentoo.org>
7# 10#
8# This is not an eclass, but it does provide emacs-related 11# This is not a real eclass, but it does provide Emacs-related installation
9# installation utilities. 12# utilities.
10 13#
11INHERITED="$INHERITED $ECLASS" 14# USAGE:
15#
16# Usually you want to use this eclass for (optional) GNU Emacs support of
17# your package. This is NOT for XEmacs!
18# Many of the steps here are sometimes done by the build system of your
19# package (especially compilation), so this is mainly for standalone elisp
20# files you gathered from somewhere else.
21# When relying on the emacs USE flag, you need to add
22#
23# emacs? ( virtual/emacs )
24#
25# to your DEPEND/RDEPEND line and use the functions provided here to bring
26# the files to the correct locations.
27#
28# src_compile() usage:
29# --------------------
30#
31# An elisp file is compiled by the elisp-compile() function defined here and
32# simply takes the source files as arguments. In the case of interdependent
33# elisp files, you can use the elisp-comp() function which makes sure all
34# files are loadable.
35#
36# elisp-compile *.el || die "elisp-compile failed"
37# or
38# elisp-comp *.el || die "elisp-comp failed"
39#
40# Function elisp-make-autoload-file() can be used to generate a file with
41# autoload definitions for the lisp functions. It takes the output file name
42# (default: "${PN}-autoloads.el") and a list of directories (default: working
43# directory) as its arguments. Use of this function requires that the elisp
44# source files contain magic ";;;###autoload" comments. See the Emacs Lisp
45# Reference Manual (node "Autoload") for a detailed explanation.
46#
47# src_install() usage:
48# --------------------
49#
50# The resulting compiled files (.elc) should be put in a subdirectory of
51# /usr/share/emacs/site-lisp/ which is named after the first argument
52# of elisp-install(). The following parameters are the files to be put in
53# that directory. Usually the subdirectory should be ${PN}, you can choose
54# something else, but remember to tell elisp-site-file-install() (see below)
55# the change, as it defaults to ${PN}.
56#
57# elisp-install ${PN} *.el *.elc || die "elisp-install failed"
58#
59# To let the Emacs support be activated by Emacs on startup, you need
60# to provide a site file (shipped in ${FILESDIR}) which contains the startup
61# code (have a look in the documentation of your software). Normally this
62# would look like this:
63#
64# ;;; csv-mode site-lisp configuration
65#
66# (add-to-list 'load-path "@SITELISP@")
67# (add-to-list 'auto-mode-alist '("\\.csv\\'" . csv-mode))
68# (autoload 'csv-mode "csv-mode" "Major mode for editing csv files." t)
69#
70# If your Emacs support files are installed in a subdirectory of
71# /usr/share/emacs/site-lisp/ (which is recommended if more than one file is
72# installed), you need to extend Emacs' load-path as shown in the first
73# non-comment. The elisp-site-file-install() function of this eclass will
74# replace "@SITELISP@" by the actual path.
75# The next line tells Emacs to load the mode opening a file ending with
76# ".csv" and load functions depending on the context and needed features.
77# Be careful though. Commands as "load-library" or "require" bloat the
78# editor as they are loaded on every startup. When having a lot of Emacs
79# support files, users may be annoyed by the start-up time. Also avoid
80# keybindings as they might interfere with the user's settings. Give a hint
81# in pkg_postinst(), which should be enough.
82# The naming scheme for this site file is "[0-9][0-9]*-gentoo.el", where the
83# two digits at the beginning define the loading order. So if you depend on
84# another Emacs package, your site file's number must be higher!
85# Best practice is to define a SITEFILE variable in the global scope of your
86# ebuild (right after DEPEND e.g.):
87#
88# SITEFILE=50${PN}-gentoo.el
89#
90# Which is then installed by
91#
92# elisp-site-file-install "${FILESDIR}/${SITEFILE}"
93#
94# in src_install(). If your subdirectory is not named ${PN}, give the
95# differing name as second argument.
96#
97# pkg_postinst() / pkg_postrm() usage:
98# ------------------------------------
99#
100# After that you need to recreate the start-up file of Emacs after emerging
101# and unmerging by using
102#
103# pkg_postinst() {
104# elisp-site-regen
105# }
106#
107# pkg_postrm() {
108# elisp-site-regen
109# }
110#
111# When having optional Emacs support, you should prepend "use emacs &&" to
112# above calls of elisp-site-regen(). Don't use "has_version virtual/emacs"!
113# When unmerging the state of the USE flag emacs is taken from the package
114# database and not from the environment, so it is no problem when you unset
115# USE=emacs between merge und unmerge of a package.
116#
117# Miscellaneous functions:
118# ------------------------
119#
120# elisp-emacs-version() outputs the version of the currently active Emacs.
121#
122# As always: Feel free to contact Emacs team through emacs@gentoo.org if you
123# have problems, suggestions or questions.
12 124
13SITELISP=/usr/share/emacs/site-lisp 125SITELISP=/usr/share/emacs/site-lisp
14 126
15elisp-compile() { 127elisp-compile() {
16 /usr/bin/emacs --batch -f batch-byte-compile --no-site-file --no-init-file $* 128 einfo "Compiling GNU Emacs Elisp files ..."
129 /usr/bin/emacs -batch -q --no-site-file -f batch-byte-compile $*
130}
131
132elisp-emacs-version() {
133 # Output version of currently active Emacs.
134 # The following will work for at least versions 18-22.
135 echo "(princ emacs-version)" >"${T}"/emacs-version.el
136 /usr/bin/emacs -batch -q --no-site-file -l "${T}"/emacs-version.el
137}
138
139elisp-make-autoload-file () {
140 local f="${1:-${PN}-autoloads.el}"
141 shift
142 einfo "Generating autoload file for GNU Emacs ..."
143
144 sed 's/^FF/\f/' >"${f}" <<-EOF
145 ;;; ${f##*/} --- autoloads for ${P}
146
147 ;;; Commentary:
148 ;; Automatically generated by elisp-common.eclass
149 ;; DO NOT EDIT THIS FILE
150
151 ;;; Code:
152 FF
153 ;; Local Variables:
154 ;; version-control: never
155 ;; no-byte-compile: t
156 ;; no-update-autoloads: t
157 ;; End:
158 ;;; ${f##*/} ends here
159 EOF
160
161 /usr/bin/emacs -batch -q --no-site-file \
162 --eval "(setq make-backup-files nil)" \
163 --eval "(setq generated-autoload-file (expand-file-name \"${f}\"))" \
164 -f batch-update-autoloads "${@-.}"
17} 165}
18 166
19elisp-install() { 167elisp-install() {
20 local subdir=$1 168 local subdir=$1
169 einfo "Installing Elisp files for GNU Emacs support ..."
21 dodir ${SITELISP}/${subdir} 170 dodir "${SITELISP}/${subdir}"
22 insinto ${SITELISP}/${subdir} 171 insinto "${SITELISP}/${subdir}"
23 shift 172 shift
24 doins $@ 173 doins $@
25} 174}
26 175
27elisp-site-file-install() { 176elisp-site-file-install() {
28 local sitefile=$1 my_pn=${2:-${PN}} 177 local sitefile=$1 my_pn=${2:-${PN}}
178 einfo "Installing site initialisation file for GNU Emacs ..."
29 pushd ${S} 179 pushd "${S}"
30 cp ${sitefile} ${T} 180 cp ${sitefile} "${T}"
31 sed -i "s:@SITELISP@:${SITELISP}/${my_pn}:g" ${T}/$(basename ${sitefile}) 181 sed -i "s:@SITELISP@:${SITELISP}/${my_pn}:g" "${T}/$(basename ${sitefile})"
32 insinto ${SITELISP} 182 insinto ${SITELISP}
33 doins ${T}/$(basename ${sitefile}) || die "failed to install site file" 183 doins "${T}/$(basename ${sitefile})" || die "failed to install site file"
34 popd 184 popd
35} 185}
36 186
37elisp-site-regen() { 187elisp-site-regen() {
188 local sflist sf line
189
38 einfo "Regenerating ${SITELISP}/site-gentoo.el ..." 190 einfo "Regenerating ${SITELISP}/site-gentoo.el ..."
39 einfo ""
40 cat <<EOF >${SITELISP}/site-gentoo.el 191 cat <<-EOF >"${T}"/site-gentoo.el
41;;; DO NOT EDIT THIS FILE -- IT IS GENERATED AUTOMATICALLY BY PORTAGE 192 ;;; site-gentoo.el --- site initialisation for Gentoo-installed packages
42;;; -----------------------------------------------------------------
43 193
194 ;;; Commentary:
195 ;; Automatically generated by elisp-common.eclass
196 ;; DO NOT EDIT THIS FILE
197
198 ;;; Code:
44EOF 199 EOF
45 ls ${SITELISP}/[0-9][0-9]*-gentoo.el |sort -n | \ 200
46 while read sf 201 for sf in "${ROOT}${SITELISP}"/[0-9][0-9]*-gentoo.el
47 do 202 do
48 einfo " Adding $(basename $sf) ..." 203 [ -r "${sf}" ] || continue
49 # Great for debugging, too noisy and slow for users though 204 sflist="${sflist} $(basename "${sf}")"
50# echo "(message \"Loading $sf ...\")" >>${SITELISP}/site-start.el
51 cat $sf >>${SITELISP}/site-gentoo.el 205 cat "${sf}" >>"${T}"/site-gentoo.el
52 done 206 done
207
208 cat <<-EOF >>"${T}"/site-gentoo.el
209
210 ;;; site-gentoo.el ends here
211 EOF
212
213 if cmp -s "${ROOT}${SITELISP}"/site-gentoo.el "${T}"/site-gentoo.el; then
214 # This prevents outputting unnecessary text when there
215 # was actually no change
216 # A case is a remerge where we have doubled output
217 einfo "... no changes"
218 else
219 mv "${T}"/site-gentoo.el "${ROOT}${SITELISP}"/site-gentoo.el
220 einfo ""
221 for sf in ${sflist}; do
222 einfo " Adding ${sf} ..."
223 done
53 while read line; do einfo "${line}"; done <<EOF 224 while read line; do einfo "${line}"; done <<EOF
54 225
55All site initialization for Gentoo-installed packages is now added to 226All site initialisation for Gentoo-installed packages is now added to
56/usr/share/emacs/site-lisp/site-gentoo.el; site-start.el is no longer 227/usr/share/emacs/site-lisp/site-gentoo.el; site-start.el is no longer
57managed by Gentoo. You are responsible for all maintenance of 228managed by Gentoo. You are responsible for all maintenance of
58site-start.el if there is such a file. 229site-start.el if there is such a file.
59 230
60In order for this site initialization to be loaded for all users 231In order for this site initialisation to be loaded for all users
61automatically, as was done previously, you can add a line like this: 232automatically, as was done previously, you can add a line like this:
62 233
63 (load "/usr/share/emacs/site-lisp/site-gentoo") 234 (load "/usr/share/emacs/site-lisp/site-gentoo" nil t)
64 235
65to /usr/share/emacs/site-lisp/site-start.el. Alternatively, that line 236to /usr/share/emacs/site-lisp/site-start.el. Alternatively, that line
66can be added by individual users to their initialization files, or for 237can be added by individual users to their initialisation files, or for
67greater flexibility, users can select which of the package-specific 238greater flexibility, users can select which of the package-specific
68initialization files in /usr/share/emacs/site-lisp to load. 239initialisation files in /usr/share/emacs/site-lisp to load.
69EOF 240EOF
70 echo 241 echo
242 fi
71} 243}
72 244
73# The following Emacs Lisp compilation routine is taken from GNU 245# The following Emacs Lisp compilation routine was originally taken from
74# autotools. 246# GNU autotools.
75 247
76elisp-comp() { 248elisp-comp() {
77# Copyright 1995 Free Software Foundation, Inc. 249 # Copyright 1995 Free Software Foundation, Inc.
78# Franois Pinard <pinard@iro.umontreal.ca>, 1995. 250 # Franรงois Pinard <pinard@iro.umontreal.ca>, 1995.
79#
80# This program is free software; you can redistribute it and/or modify
81# it under the terms of the GNU General Public License as published by
82# the Free Software Foundation; either version 2, or (at your option)
83# any later version.
84#
85# This program is distributed in the hope that it will be useful,
86# but WITHOUT ANY WARRANTY; without even the implied warranty of
87# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
88# GNU General Public License for more details.
89#
90# You should have received a copy of the GNU General Public License
91# along with this program; if not, write to the Free Software
92# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
93
94# As a special exception to the GNU General Public License, if you
95# distribute this file as part of a program that contains a
96# configuration script generated by Autoconf, you may include it under
97# the same distribution terms that you use for the rest of that program.
98
99# This script byte-compiles all `.el' files which are part of its 251 # This script byte-compiles all `.el' files which are part of its
100# arguments, using GNU Emacs, and put the resulting `.elc' files into 252 # arguments, using GNU Emacs, and put the resulting `.elc' files into
101# the current directory, so disregarding the original directories used 253 # the current directory, so disregarding the original directories used
102# in `.el' arguments. 254 # in `.el' arguments.
103# 255 #
104# This script manages in such a way that all Emacs LISP files to 256 # This script manages in such a way that all Emacs LISP files to
105# be compiled are made visible between themselves, in the event 257 # be compiled are made visible between themselves, in the event
106# they require or load-library one another. 258 # they require or load-library one another.
107 259
108 if test $# = 0; then 260 test $# -gt 0 || return 1
109 echo 1>&2 "No files given to $0" 261
110 exit 1
111 else
112 if test -z "$EMACS" || test "$EMACS" = "t"; then 262 if test -z "${EMACS}" || test "${EMACS}" = "t"; then
113 # Value of "t" means we are running in a shell under Emacs. 263 # Value of "t" means we are running in a shell under Emacs.
114 # Just assume Emacs is called "emacs". 264 # Just assume Emacs is called "emacs".
115 EMACS=emacs 265 EMACS=/usr/bin/emacs
116 fi
117
118 tempdir=elc.$$
119 mkdir $tempdir
120 cp $* $tempdir
121 cd $tempdir
122
123 echo "(add-to-list 'load-path \"../\")" > script
124 $EMACS -batch -q --no-site-file --no-init-file -l script -f batch-byte-compile *.el
125 mv *.elc ..
126
127 cd ..
128 rm -fr $tempdir
129 fi 266 fi
130} 267 einfo "Compiling GNU Emacs Elisp files ..."
131 268
132# Local Variables: *** 269 tempdir=elc.$$
133# mode: shell-script *** 270 mkdir ${tempdir}
134# tab-width: 4 *** 271 cp $* ${tempdir}
135# indent-tabs-mode: t *** 272 pushd ${tempdir}
136# End: ***
137 273
274 echo "(add-to-list 'load-path \"../\")" > script
275 ${EMACS} -batch -q --no-site-file --no-init-file -l script \
276 -f batch-byte-compile *.el
277 local status=$?
278 mv *.elc ..
279
280 popd
281 rm -fr ${tempdir}
282 return ${status}
283}

Legend:
Removed from v.1.11  
changed lines
  Added in v.1.24

  ViewVC Help
Powered by ViewVC 1.1.20